"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.opt = exports.getRoleInfo = exports.BaseAuth = void 0;
const egg_1 = require("egg");
const util_1 = require("../util");
class BaseAuth extends egg_1.Service {
}
exports.BaseAuth = BaseAuth;
const infoSymbol = Symbol('InfoSymbol');
function getRoleInfo(roleType) {
    const desc = Object.getOwnPropertyDescriptor(roleType, infoSymbol);
    if (!desc) {
        const info = {
            params: util_1.getParameterNames(roleType.prototype.has).map(name => ({ name, required: true })),
        };
        Object.defineProperty(roleType, infoSymbol, {
            value: info,
        });
        return getRoleInfo(roleType);
    }
    return desc.value;
}
exports.getRoleInfo = getRoleInfo;
/** opt param for BaseAuth */
function opt() {
    return (target, key, index) => {
        const info = getRoleInfo(target.constructor);
        info.params[index].required = false;
    };
}
exports.opt = opt;
