"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.genAPISDK = void 0;
const tslib_1 = require("tslib");
const path = require("path");
const meta_1 = require("../meta");
const utils = require('egg-utils');
function genAPISDK(baseDir) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const framework = utils.getFrameworkPath({ baseDir });
        const appConfig = utils.getConfig({ baseDir, framework });
        let _a = appConfig.controller.genSDK, { filter } = _a, rest = tslib_1.__rest(_a, ["filter"]);
        rest.sdkDir = path.isAbsolute(rest.sdkDir) ? rest.sdkDir : path.join(baseDir, rest.sdkDir);
        yield Promise.all([]
            .concat(appConfig.controller.ctrlDir)
            .map(dir => (path.isAbsolute(dir) ? dir : path.join(baseDir, dir)))
            .map((dir) => tslib_1.__awaiter(this, void 0, void 0, function* () { return meta_1.genAPISDKByPath(dir, filter, rest, appConfig); })));
        console.log('[egg-controller] gen api sdk.');
    });
}
exports.genAPISDK = genAPISDK;
