"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const openapi_generator_1 = require("openapi-generator");
const controller_1 = require("../controller");
const util_1 = require("../util");
const openapi_1 = require("../openapi");
process.on('message', (message) => {
    try {
        const { files, filter, config, appConfig } = message;
        if (config.hook) {
            Object.keys(config.hook).forEach(key => {
                if (typeof config.hook[key] === 'string') {
                    config.hook[key] = new Function(`return ${config.hook[key]}`)();
                }
            });
        }
        files.forEach(file => util_1.loadFile(file));
        const openAPIData = openapi_1.convertToOpenAPI({
            base: { version: '1.0', title: '' },
        }, controller_1.getRoutes(appConfig).filter(route => {
            return filter.some(r => {
                const match = r.match(new RegExp('^/(.*?)/([gimyu]*)$'));
                const regex = new RegExp(match[1], match[2]);
                return [].concat(route.url).some(url => regex.test(url.toString()));
            });
        }));
        openapi_generator_1.genFromData(Object.assign({}, config), openAPIData);
    }
    catch (error) {
        console.log('[GenSDK Error]', error);
    }
    process.exit(0);
});
process.send('gensdk:ready');
